Merge branch 'format/funcs' of https://github.com/anntnzrb/LARBS into anntnzrb-format/funcs

This commit is contained in:
Luke Smith 2022-06-29 16:28:56 -04:00
commit 01c03f8537

154
larbs.sh
View File

@ -13,17 +13,26 @@ repobranch="master"
### FUNCTIONS ###
installpkg(){ pacman --noconfirm --needed -S "$1" >/dev/null 2>&1 ;}
installpkg() {
pacman --noconfirm --needed -S "$1" >/dev/null 2>&1
}
error() { printf "%s\n" "$1" >&2; exit 1; }
error() {
# Log to stderr and exit with failure.
printf "%s\n" "$1" >&2
exit 1
}
welcomemsg() { \
dialog --title "Welcome!" --msgbox "Welcome to Luke's Auto-Rice Bootstrapping Script!\\n\\nThis script will automatically install a fully-featured Linux desktop, which I use as my main machine.\\n\\n-Luke" 10 60
welcomemsg() {
dialog --title "Welcome!" \
--msgbox "Welcome to Luke's Auto-Rice Bootstrapping Script!\\n\\nThis script will automatically install a fully-featured Linux desktop, which I use as my main machine.\\n\\n-Luke" 10 60
dialog --colors --title "Important Note!" --yes-label "All ready!" --no-label "Return..." --yesno "Be sure the computer you are using has current pacman updates and refreshed Arch keyrings.\\n\\nIf it does not, the installation of some programs might fail." 8 70
}
dialog --colors --title "Important Note!" --yes-label "All ready!" \
--no-label "Return..." \
--yesno "Be sure the computer you are using has current pacman updates and refreshed Arch keyrings.\\n\\nIf it does not, the installation of some programs might fail." 8 70
}
getuserandpass() { \
getuserandpass() {
# Prompts user for new username an password.
name=$(dialog --inputbox "First, please enter a name for the user account." 10 60 3>&1 1>&2 2>&3 3>&1) || exit 1
while ! echo "$name" | grep -q "^[a-z_][a-z0-9_-]*$"; do
@ -35,27 +44,33 @@ getuserandpass() { \
unset pass2
pass1=$(dialog --no-cancel --passwordbox "Passwords do not match.\\n\\nEnter password again." 10 60 3>&1 1>&2 2>&3 3>&1)
pass2=$(dialog --no-cancel --passwordbox "Retype password." 10 60 3>&1 1>&2 2>&3 3>&1)
done ;}
done
}
usercheck() { \
usercheck() {
! { id -u "$name" >/dev/null 2>&1; } ||
dialog --colors --title "WARNING!" --yes-label "CONTINUE" --no-label "No wait..." --yesno "The user \`$name\` already exists on this system. LARBS can install for a user already existing, but it will \\Zboverwrite\\Zn any conflicting settings/dotfiles on the user account.\\n\\nLARBS will \\Zbnot\\Zn overwrite your user files, documents, videos, etc., so don't worry about that, but only click <CONTINUE> if you don't mind your settings being overwritten.\\n\\nNote also that LARBS will change $name's password to the one you just gave." 14 70
}
dialog --colors --title "WARNING!" --yes-label "CONTINUE" \
--no-label "No wait..." \
--yesno "The user \`$name\` already exists on this system. LARBS can install for a user already existing, but it will \\Zboverwrite\\Zn any conflicting settings/dotfiles on the user account.\\n\\nLARBS will \\Zbnot\\Zn overwrite your user files, documents, videos, etc., so don't worry about that, but only click <CONTINUE> if you don't mind your settings being overwritten.\\n\\nNote also that LARBS will change $name's password to the one you just gave." 14 70
}
preinstallmsg() { \
dialog --title "Let's get this party started!" --yes-label "Let's go!" --no-label "No, nevermind!" --yesno "The rest of the installation will now be totally automated, so you can sit back and relax.\\n\\nIt will take some time, but when done, you can relax even more with your complete system.\\n\\nNow just press <Let's go!> and the system will begin installation!" 13 60 || { clear; exit 1; }
}
preinstallmsg() {
dialog --title "Let's get this party started!" --yes-label "Let's go!" \
--no-label "No, nevermind!" \
--yesno "The rest of the installation will now be totally automated, so you can sit back and relax.\\n\\nIt will take some time, but when done, you can relax even more with your complete system.\\n\\nNow just press <Let's go!> and the system will begin installation!" 13 60 || { clear; exit 1; }
}
adduserandpass() { \
adduserandpass() {
# Adds user `$name` with password $pass1.
dialog --infobox "Adding user \"$name\"..." 4 50
useradd -m -g wheel -s /bin/zsh "$name" >/dev/null 2>&1 ||
usermod -a -G wheel "$name" && mkdir -p /home/"$name" && chown "$name":wheel /home/"$name"
useradd -m -g wheel -s /bin/zsh "$name" >/dev/null 2>&1 \
|| usermod -a -G wheel "$name" && mkdir -p /home/"$name" && chown "$name":wheel /home/"$name"
export repodir="/home/$name/.local/src"; mkdir -p "$repodir"; chown -R "$name":wheel "$(dirname "$repodir")"
echo "$name:$pass1" | chpasswd
unset pass1 pass2 ;}
unset pass1 pass2
}
refreshkeys() { \
refreshkeys() {
case "$(readlink -f /sbin/init)" in
*systemd* )
dialog --infobox "Refreshing Arch Keyring..." 4 40
@ -73,7 +88,8 @@ Server = https://mirror1.cl.netactuate.com/artix/universe/\$arch
Server = https://ftp.crifo.org/artix-universe/" >> /etc/pacman.conf
pacman -Sy
fi
pacman --noconfirm --needed -S artix-keyring artix-archlinux-support >/dev/null 2>&1
pacman --noconfirm --needed -S \
artix-keyring artix-archlinux-support >/dev/null 2>&1
for repo in extra community; do
grep -q "^\[$repo\]" /etc/pacman.conf ||
echo "[$repo]
@ -82,89 +98,113 @@ Include = /etc/pacman.d/mirrorlist-arch" >> /etc/pacman.conf
pacman -Sy >/dev/null 2>&1
pacman-key --populate archlinux >/dev/null 2>&1
;;
esac ;}
esac
}
newperms() { # Set special sudoers settings for install (or after).
newperms() {
# Set special sudoers settings for install (or after).
sed -i "/#LARBS/d" /etc/sudoers
echo "$* #LARBS" >> /etc/sudoers ;}
echo "$* #LARBS" >> /etc/sudoers
}
manualinstall() { # Installs $1 manually. Used only for AUR helper here.
manualinstall() {
# Installs $1 manually. Used only for AUR helper here.
# Should be run after repodir is created and var is set.
dialog --infobox "Installing \"$1\", an AUR helper..." 4 50
sudo -u "$name" mkdir -p "$repodir/$1"
sudo -u "$name" git clone -C "$repodir/$1" --depth 1 --single-branch --no-tags -q "https://aur.archlinux.org/$1.git" "$repodir/$1" \
|| { cd "$repodir/$1" || return 1 ; sudo -u "$name" git pull --force origin master ;}
sudo -u "$name" git clone -C "$repodir/$1" --depth 1 --single-branch \
--no-tags -q "https://aur.archlinux.org/$1.git" "$repodir/$1" \
|| { cd "$repodir/$1" || return 1 ; sudo -u "$name" git pull
--force origin master ;}
cd "$repodir/$1" || exit 1
sudo -u "$name" -D "$repodir/$1" makepkg --noconfirm -si >/dev/null 2>&1 || return 1
sudo -u "$name" -D "$repodir/$1" \
makepkg --noconfirm -si >/dev/null 2>&1 || return 1
}
maininstall() { # Installs all needed programs from main repo.
maininstall() {
# Installs all needed programs from main repo.
dialog --title "LARBS Installation" --infobox "Installing \`$1\` ($n of $total). $1 $2" 5 70
installpkg "$1"
}
}
gitmakeinstall() {
progname="$(basename "$1" .git)"
dir="$repodir/$progname"
dialog --title "LARBS Installation" --infobox "Installing \`$progname\` ($n of $total) via \`git\` and \`make\`. $(basename "$1") $2" 5 70
sudo -u "$name" git clone -C "$repodir/$1" --depth 1 --single-branch --no-tags -q "$1" "$dir" || { cd "$dir" || return 1 ; sudo -u "$name" git pull --force origin master ;}
dialog --title "LARBS Installation" \
--infobox "Installing \`$progname\` ($n of $total) via \`git\` and \`make\`. $(basename "$1") $2" 5 70
sudo -u "$name" git clone -C "$repodir/$1" \
--depth 1 --single-branch --no-tags -q "$1" "$dir" \
|| { cd "$dir" || return 1 ; sudo -u "$name" git pull --force origin master ;}
cd "$dir" || exit 1
make >/dev/null 2>&1
make install >/dev/null 2>&1
cd /tmp || return 1 ;}
cd /tmp || return 1
}
aurinstall() { \
dialog --title "LARBS Installation" --infobox "Installing \`$1\` ($n of $total) from the AUR. $1 $2" 5 70
aurinstall() {
dialog --title "LARBS Installation" \
--infobox "Installing \`$1\` ($n of $total) from the AUR. $1 $2" 5 70
echo "$aurinstalled" | grep -q "^$1$" && return 1
sudo -u "$name" $aurhelper -S --noconfirm "$1" >/dev/null 2>&1
}
}
pipinstall() { \
dialog --title "LARBS Installation" --infobox "Installing the Python package \`$1\` ($n of $total). $1 $2" 5 70
pipinstall() {
dialog --title "LARBS Installation" \
--infobox "Installing the Python package \`$1\` ($n of $total). $1 $2" 5 70
[ -x "$(command -v "pip")" ] || installpkg python-pip >/dev/null 2>&1
yes | pip install "$1"
}
}
installationloop() { \
([ -f "$progsfile" ] && cp "$progsfile" /tmp/progs.csv) || curl -Ls "$progsfile" | sed '/^#/d' > /tmp/progs.csv
installationloop() {
([ -f "$progsfile" ] && cp "$progsfile" /tmp/progs.csv) \
|| curl -Ls "$progsfile" | sed '/^#/d' > /tmp/progs.csv
total=$(wc -l < /tmp/progs.csv)
aurinstalled=$(pacman -Qqm)
while IFS=, read -r tag program comment; do
n=$((n+1))
echo "$comment" | grep -q "^\".*\"$" && comment="$(echo "$comment" | sed -E "s/(^\"|\"$)//g")"
echo "$comment" | grep -q "^\".*\"$" \
&& comment="$(echo "$comment" | sed -E "s/(^\"|\"$)//g")"
case "$tag" in
"A") aurinstall "$program" "$comment" ;;
"G") gitmakeinstall "$program" "$comment" ;;
"P") pipinstall "$program" "$comment" ;;
*) maininstall "$program" "$comment" ;;
esac
done < /tmp/progs.csv ;}
done < /tmp/progs.csv
}
putgitrepo() { # Downloads a gitrepo $1 and places the files in $2 only overwriting conflicts
putgitrepo() {
# Downloads a gitrepo $1 and places the files in $2 only overwriting conflicts
dialog --infobox "Downloading and installing config files..." 4 60
[ -z "$3" ] && branch="master" || branch="$repobranch"
dir=$(mktemp -d)
[ ! -d "$2" ] && mkdir -p "$2"
chown "$name":wheel "$dir" "$2"
sudo -u "$name" git clone -C "$repodir/$1" --depth 1 --single-branch --no-tags -q --recursive -b "$branch" --recurse-submodules "$1" "$dir"
sudo -u "$name" git clone -C "$repodir/$1" \
--depth 1 --single-branch --no-tags -q --recursive \
-b "$branch" --recurse-submodules "$1" "$dir"
sudo -u "$name" cp -rfT "$dir" "$2"
}
}
systembeepoff() { dialog --infobox "Getting rid of that retarded error beep sound..." 10 50
systembeepoff() {
dialog --infobox "Getting rid of that retarded error beep sound..." 10 50
rmmod pcspkr
echo "blacklist pcspkr" > /etc/modprobe.d/nobeep.conf ;}
echo "blacklist pcspkr" > /etc/modprobe.d/nobeep.conf
}
finalize(){ \
finalize(){
dialog --infobox "Preparing welcome message..." 4 50
dialog --title "All done!" --msgbox "Congrats! Provided there were no hidden errors, the script completed successfully and all the programs and configuration files should be in place.\\n\\nTo run the new graphical environment, log out and log back in as your new user, then run the command \"startx\" to start the graphical environment (it will start automatically in tty1).\\n\\n.t Luke" 12 80
}
dialog --title "All done!" \
--msgbox "Congrats! Provided there were no hidden errors, the script completed successfully and all the programs and configuration files should be in place.\\n\\nTo run the new graphical environment, log out and log back in as your new user, then run the command \"startx\" to start the graphical environment (it will start automatically in tty1).\\n\\n.t Luke" 12 80
}
### THE ACTUAL SCRIPT ###
### This is how everything happens in an intuitive format and order.
# Check if user is root on Arch distro. Install dialog.
pacman --noconfirm --needed -Sy dialog || error "Are you sure you're running this as the root user, are on an Arch-based distribution and have an internet connection?"
pacman --noconfirm --needed -Sy dialog \
|| error "Are you sure you're running this as the root user, are on an Arch-based distribution and have an internet connection?"
# Welcome user and pick dotfiles.
welcomemsg || error "User exited."
@ -181,14 +221,17 @@ preinstallmsg || error "User exited."
### The rest of the script requires no user input.
# Refresh Arch keyrings.
refreshkeys || error "Error automatically refreshing Arch keyring. Consider doing so manually."
refreshkeys \
|| error "Error automatically refreshing Arch keyring. Consider doing so manually."
for x in curl ca-certificates base-devel git ntp zsh ; do
dialog --title "LARBS Installation" --infobox "Installing \`$x\` which is required to install and configure other programs." 5 70
dialog --title "LARBS Installation" \
--infobox "Installing \`$x\` which is required to install and configure other programs." 5 70
installpkg "$x"
done
dialog --title "LARBS Installation" --infobox "Synchronizing system time to ensure successful and secure installation of software..." 4 70
dialog --title "LARBS Installation" \
--infobox "Synchronizing system time to ensure successful and secure installation of software..." 4 70
ntpdate 0.us.pool.ntp.org >/dev/null 2>&1
adduserandpass || error "Error adding username and/or password."
@ -214,7 +257,8 @@ manualinstall yay || error "Failed to install AUR helper."
# and all build dependencies are installed.
installationloop
dialog --title "LARBS Installation" --infobox "Finally, installing \`libxft-bgra\` to enable color emoji in suckless software without crashes." 5 70
dialog --title "LARBS Installation" \
--infobox "Finally, installing \`libxft-bgra\` to enable color emoji in suckless software without crashes." 5 70
yes | sudo -u "$name" $aurhelper -S libxft-bgra-git >/dev/null 2>&1
# Install the dotfiles in the user's home directory